#==============================================================================#
#                        Copyright 2022-2024 ArchaicSoft                       #
#                                                                              #
# Boost Software License - Version 1.0 - August 17th, 2003                     #
#                                                                              #
# Permission is hereby granted, free of charge, to any person or organization  #
# obtaining a copy of the software and accompanying documentation covered by   #
# this license (the "Software") to use, reproduce, display, distribute,        #
# execute, and transmit the Software, and to prepare derivative works of the   #
# Software, and to permit third-parties to whom the Software is furnished to   #
# do so, all subject to the following:                                         #
#                                                                              #
# The copyright notices in the Software and this entire statement, including   #
# the above license grant, this restriction and the following disclaimer,      #
# must be included in all copies of the Software, in whole or in part, and     #
# all derivative works of the Software, unless such copies or derivative       #
# works are solely in the form of machine-executable object code generated by  #
# a source language processor.                                                 #
#                                                                              #
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   #
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     #
# FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT    #
# SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE    #
# FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,  #
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER  #
# DEALINGS IN THE SOFTWARE.                                                    #
#==============================================================================#

@tool extends EditorPlugin

const ADDON_PATH  : String = "res://addons/asfw/splash_screen/"
const RUN_PATH    : String = "application/run/"
const SPLASH_PATH : String = "application/boot_splash/"

func _enter_tree() -> void:
	hide_settings(true)
	ProjectSettings.save()

func _enable_plugin() -> void:
	# assign ourselves to startup scene
	set_startup_scenes()
	
	# set some initial values for splash screen based on this addon
	write_setting(SPLASH_PATH + "bg_color", Color.WHITE)
	write_setting(SPLASH_PATH + "image", ADDON_PATH + "splash.svg")
	
	# foreground color (fade in/out color scheme)
	write_setting(SPLASH_PATH + "fg_color", Color.BLACK,
		ProjectSettings.get_order(SPLASH_PATH + "bg_color") + 1)
	
	# fade in/out speed by frame ticks
	write_setting(SPLASH_PATH + "fade_speed", 100)
	
	# hide the old splash values
	hide_settings(true)
	
	# make changes permanent
	ProjectSettings.save()

func _disable_plugin() -> void:
	# re-assign ourselves to main scene
	unset_startup_scenes()
	
	# remove initial values for splash screen based on this addon
	write_setting(SPLASH_PATH + "bg_color", Color(.14, .14, .14))
	write_setting(SPLASH_PATH + "image", "")
	
	# foreground color (fade in/out color scheme)
	ProjectSettings.clear(SPLASH_PATH + "fg_color")
	
	# fade in/out speed by frame ticks
	ProjectSettings.clear(SPLASH_PATH + "fade_speed")
	
	# show the old splash values
	hide_settings(false)
	
	# make changes permanent
	ProjectSettings.save()

func hide_settings(value: bool) -> void:
	ProjectSettings.set_as_internal(RUN_PATH    + "main_scene",           value)
	ProjectSettings.set_as_internal(SPLASH_PATH + "fullsize",             value)
	ProjectSettings.set_as_internal(SPLASH_PATH + "use_filter",           value)
	ProjectSettings.set_as_internal(SPLASH_PATH + "minimum_display_time", value)

func set_startup_scenes() -> void:
	var main_scene  : String = RUN_PATH + "main_scene"
	var main_value  : String = ProjectSettings.get_setting(main_scene)
	var splash_path : String = ADDON_PATH + "Splash.tscn"
	
	# prevent recursive scene transition loop
	var start_scene : String = RUN_PATH + "start_scene"
	if main_value == splash_path: main_value = ""
	
	# redirect splash screen as main scene and primary scene to next scene
	ProjectSettings.set_setting(main_scene, splash_path)
	
	write_setting(start_scene, main_value,
		ProjectSettings.get_order(main_scene))
	ProjectSettings.set_initial_value(start_scene, "")
	
	ProjectSettings.add_property_info({
		"name": start_scene,
		"type": TYPE_STRING,
		"hint": PROPERTY_HINT_GLOBAL_FILE,
		"hint_string": "*.tscn"
	})

func unset_startup_scenes() -> void:
	var main_scene  : String = RUN_PATH + "main_scene"
	var start_scene : String = RUN_PATH + "start_scene"
	
	# revert our start scene to main scene
	ProjectSettings.set_setting(main_scene,
		ProjectSettings.get_setting(start_scene))
	
	ProjectSettings.clear(start_scene)

func write_setting(setting: String, value: Variant, position: int = -1) -> void:
	ProjectSettings.set_setting(setting, value)
	
	if position < 0: return
	ProjectSettings.set_order(setting, position)
